'use strict';

exports.__esModule = true;
exports.closeToken = exports.saveToken = exports.loadToken = undefined;

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var loadToken = exports.loadToken = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return fs.exists('.update');

          case 2:
            if (!_context.sent) {
              _context.next = 18;
              break;
            }

            _context.prev = 3;
            _context.t0 = replaceToken;
            _context.t1 = JSON;
            _context.next = 8;
            return fs.readFile('.update', 'utf8');

          case 8:
            _context.t2 = _context.sent;
            _context.t3 = _context.t1.parse.call(_context.t1, _context.t2);
            (0, _context.t0)(_context.t3);

            savedToken = Token;
            _context.next = 18;
            break;

          case 14:
            _context.prev = 14;
            _context.t4 = _context['catch'](3);

            console.error('Failed to parse file `.update`. Try to remove it manually.');
            throw _context.t4;

          case 18:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[3, 14]]);
  }));

  return function loadToken() {
    return _ref.apply(this, arguments);
  };
}();

var saveToken = exports.saveToken = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
    var current, data;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (!(Token !== savedToken)) {
              _context2.next = 6;
              break;
            }

            current = Token;
            data = (0, _stringify2.default)(current, null, 4);
            _context2.next = 5;
            return fs.writeFile('.update', data, 'utf8');

          case 5:
            savedToken = current;

          case 6:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function saveToken() {
    return _ref2.apply(this, arguments);
  };
}();

var closeToken = exports.closeToken = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return fs.exists('.update');

          case 2:
            if (!_context3.sent) {
              _context3.next = 6;
              break;
            }

            _context3.next = 5;
            return fs.unlink('.update');

          case 5:
            savedToken = undefined;

          case 6:
            Token = undefined;
            host = process.env.RNKIT_CODE_PUSH_HOST || 'https://update.rnkit.io/v1/api/';

          case 8:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function closeToken() {
    return _ref3.apply(this, arguments);
  };
}();

var query = function () {
  var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(url, options) {
    var resp, json;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return fetch(url, options);

          case 2:
            resp = _context4.sent;
            _context4.next = 5;
            return resp.json();

          case 5:
            json = _context4.sent;

            if (!(json.errno === 401)) {
              _context4.next = 12;
              break;
            }

            console.log(_colors2.default.red('Not loggined.'));
            console.log('Run `rnkit-code-push login` at your project directory to login.');
            process.exit(1);
            _context4.next = 14;
            break;

          case 12:
            if (!(json.errno !== 0)) {
              _context4.next = 14;
              break;
            }

            throw new Error(_colors2.default.red('errno:' + json.errno + '  msg:' + (0, _stringify2.default)(json.errmsg)));

          case 14:
            return _context4.abrupt('return', json.data);

          case 15:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function query(_x, _x2) {
    return _ref4.apply(this, arguments);
  };
}();

var uploadFile = function () {
  var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(fn) {
    var _ref6, token, up_host, realUrl, formData, fileSize, bar, info;

    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return exports.post('/file/token', {});

          case 2:
            _ref6 = _context5.sent;
            token = _ref6.token;
            up_host = _ref6.up_host;
            realUrl = up_host;
            formData = {
              token: token,
              accept: 'application/json'
            };
            _context5.next = 9;
            return fs.stat(fn);

          case 9:
            fileSize = _context5.sent.size;
            bar = new _progress2.default('  Uploading [:bar] :percent :etas', {
              complete: '=',
              incomplete: ' ',
              total: fileSize
            });
            _context5.next = 13;
            return new _promise2.default(function (resolve, reject) {
              formData.file = fsOrigin.createReadStream(fn);

              formData.file.on('data', function (data) {
                bar.tick(data.length);
              });
              _request2.default.post(realUrl, {
                formData: formData
              }, function (err, resp, body) {
                if (err) {
                  return reject(err);
                }
                if (resp.statusCode > 299) {
                  return reject((0, _assign2.default)(new Error(body), { status: resp.statusCode }));
                }
                resolve(JSON.parse(body));
              });
            });

          case 13:
            info = _context5.sent;
            return _context5.abrupt('return', info);

          case 15:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function uploadFile(_x3) {
    return _ref5.apply(this, arguments);
  };
}();

exports.getToken = getToken;
exports.replaceToken = replaceToken;

var _fs = require('fs');

var fsOrigin = _interopRequireWildcard(_fs);

var _request = require('request');

var _request2 = _interopRequireDefault(_request);

var _progress = require('progress');

var _progress2 = _interopRequireDefault(_progress);

var _colors = require('colors');

var _colors2 = _interopRequireDefault(_colors);

var _querystring = require('querystring');

var _querystring2 = _interopRequireDefault(_querystring);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fetch = require('isomorphic-fetch');
var host = process.env.RNKIT_CODE_PUSH_HOST || 'https://update.rnkit.io/api/v1';
var fs = require('fs-promise');


var Token = void 0;
var savedToken = void 0;

function getToken() {
  return Token;
}

function replaceToken(newToken) {
  Token = newToken;
}

function queryWithoutBody(method) {
  return function (api) {
    return query(host + api, {
      method: method,
      headers: {
        'X-Authorization': Token ? Token.token : ''
      }
    });
  };
}

function queryWithBody(method) {
  return function (api, body) {
    return query(host + api, {
      method: method,
      headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'X-Authorization': Token ? Token.token : ''
      },
      body: _querystring2.default.stringify(body)
    });
  };
}

exports.get = queryWithoutBody('GET');
exports.post = queryWithBody('POST');
exports.put = queryWithBody('PUT');
exports.doDelete = queryWithBody('DELETE');

exports.uploadFile = uploadFile;