'use strict';

exports.__esModule = true;
exports.selectApp = exports.chooseApp = exports.listApp = exports.getSelectedApp = undefined;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var getSelectedApp = exports.getSelectedApp = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(platform, app_key_path) {
    var updateInfo;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            checkPlatform(platform);

            if (!app_key_path) app_key_path = 'rnkit-code-push.json';

            _context.next = 4;
            return fs.exists(app_key_path);

          case 4:
            if (_context.sent) {
              _context.next = 6;
              break;
            }

            throw new Error('App not selected. run \'rnkit-code-push bindApp ' + platform + '\' first!');

          case 6:
            _context.t0 = JSON;
            _context.next = 9;
            return fs.readFile(app_key_path, 'utf8');

          case 9:
            _context.t1 = _context.sent;
            updateInfo = _context.t0.parse.call(_context.t0, _context.t1);

            if (updateInfo[platform]) {
              _context.next = 13;
              break;
            }

            throw new Error('App not selected. run \'rnkit-code-push bindApp ' + platform + '\' first!');

          case 13:
            return _context.abrupt('return', updateInfo[platform]);

          case 14:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function getSelectedApp(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var listApp = exports.listApp = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
    var platform = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

    var _ref3, data;

    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return get('/app/list?page_size=20&platform=' + platform);

          case 2:
            _ref3 = _context2.sent;
            data = _ref3.data;
            return _context2.abrupt('return', data);

          case 5:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function listApp() {
    return _ref2.apply(this, arguments);
  };
}();

var chooseApp = exports.chooseApp = function () {
  var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(platform) {
    var _this = this;

    var list, _loop, _ret;

    return _regenerator2.default.wrap(function _callee3$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return listApp(platform);

          case 2:
            list = _context4.sent;
            _loop = /*#__PURE__*/_regenerator2.default.mark(function _loop() {
              var id, app;
              return _regenerator2.default.wrap(function _loop$(_context3) {
                while (1) {
                  switch (_context3.prev = _context3.next) {
                    case 0:
                      _context3.next = 2;
                      return (0, _utils.question)('Enter appId:');

                    case 2:
                      id = _context3.sent;
                      app = list.find(function (v) {
                        return v.id === (id | 0);
                      });

                      if (!app) {
                        _context3.next = 6;
                        break;
                      }

                      return _context3.abrupt('return', {
                        v: app
                      });

                    case 6:
                    case 'end':
                      return _context3.stop();
                  }
                }
              }, _loop, _this);
            });

          case 4:
            if (!true) {
              _context4.next = 11;
              break;
            }

            return _context4.delegateYield(_loop(), 't0', 6);

          case 6:
            _ret = _context4.t0;

            if (!((typeof _ret === 'undefined' ? 'undefined' : (0, _typeof3.default)(_ret)) === "object")) {
              _context4.next = 9;
              break;
            }

            return _context4.abrupt('return', _ret.v);

          case 9:
            _context4.next = 4;
            break;

          case 11:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee3, this);
  }));

  return function chooseApp(_x4) {
    return _ref4.apply(this, arguments);
  };
}();

var selectApp = exports.selectApp = function () {
  var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(appName, appKey, platform, app_key_path) {
    var updateInfo;
    return _regenerator2.default.wrap(function _callee4$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            updateInfo = {};

            if (!app_key_path) app_key_path = 'rnkit-code-push.json';
            _context5.next = 4;
            return fs.exists(app_key_path);

          case 4:
            if (!_context5.sent) {
              _context5.next = 17;
              break;
            }

            _context5.prev = 5;
            _context5.t0 = JSON;
            _context5.next = 9;
            return fs.readFile(app_key_path, 'utf8');

          case 9:
            _context5.t1 = _context5.sent;
            updateInfo = _context5.t0.parse.call(_context5.t0, _context5.t1);
            _context5.next = 17;
            break;

          case 13:
            _context5.prev = 13;
            _context5.t2 = _context5['catch'](5);

            console.error('Failed to parse file `' + app_key_path + '`. Try to remove it manually.');
            throw _context5.t2;

          case 17:
            updateInfo[platform] = {
              appName: appName,
              appKey: appKey
            };
            _context5.next = 20;
            return fs.writeFile(app_key_path, (0, _stringify2.default)(updateInfo, null, 4), 'utf8');

          case 20:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee4, this, [[5, 13]]);
  }));

  return function selectApp(_x5, _x6, _x7, _x8) {
    return _ref5.apply(this, arguments);
  };
}();

exports.checkPlatform = checkPlatform;

var _utils = require('./utils');

var _fsPromise = require('fs-promise');

var fs = _interopRequireWildcard(_fsPromise);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Created by tdzl2003 on 2/13/16.
 */

var _require = require('./api'),
    get = _require.get;

var validPlatforms = {
  ios: 1,
  android: 1
};

function checkPlatform(platform) {
  if (!validPlatforms[platform]) {
    throw new Error('Invalid platform \'' + platform + '\'');
  }
  return platform;
}