'use strict';

exports.__esModule = true;
exports.bundleApp = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var pack = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(dir, output) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return mkdir(path.dirname(output));

          case 2:
            _context.next = 4;
            return new _promise2.default(function (resolve, reject) {
              var zipfile = new _yazl.ZipFile();

              function addDirectory(root, rel) {
                if (rel) {
                  zipfile.addEmptyDirectory(rel);
                }
                var childs = fs.readdirSync(root);
                for (var _iterator = childs, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : (0, _getIterator3.default)(_iterator);;) {
                  var _ref2;

                  if (_isArray) {
                    if (_i >= _iterator.length) break;
                    _ref2 = _iterator[_i++];
                  } else {
                    _i = _iterator.next();
                    if (_i.done) break;
                    _ref2 = _i.value;
                  }

                  var name = _ref2;

                  if (name === '.' || name === '..') {
                    continue;
                  }
                  var fullPath = path.join(root, name);
                  var stat = fs.statSync(fullPath);
                  if (stat.isFile()) {
                    // console.log('adding: ' + rel+name);
                    zipfile.addFile(fullPath, rel + name);
                  } else if (stat.isDirectory()) {
                    // console.log('adding: ' + rel+name+'/');
                    addDirectory(fullPath, rel + name + '/');
                  }
                }
              }

              addDirectory(dir, '');

              zipfile.outputStream.on('error', function (err) {
                return reject(err);
              });
              zipfile.outputStream.pipe(fs.createWriteStream(output)).on('close', function () {
                resolve();
              });
              zipfile.end();
            });

          case 4:
            console.log('Bundled saved to: ' + output);

          case 5:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function pack(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var bundleApp = exports.bundleApp = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(options) {
    var reactNativeBundle = function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt('return', new _promise2.default(function (resolve, reject) {
                  reactNativeBundleProcess.stdout.on('data', function (data) {
                    console.log(data.toString().trim());
                  });

                  reactNativeBundleProcess.stderr.on('data', function (data) {
                    console.error(data.toString().trim());
                  });

                  reactNativeBundleProcess.on('close', function (exitCode) {
                    if (exitCode) {
                      console.log(_colors2.default.red('"react-native bundle" command exited with code ' + exitCode + '.'));
                      reject(new Error('"react-native bundle" command exited with code ' + exitCode + '.'));
                    }
                    resolve(null);
                  });
                }));

              case 1:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function reactNativeBundle() {
        return _ref4.apply(this, arguments);
      };
    }();

    var platform, dev, entryFile, output, intermediaDir, _getRNVersion, version, major, minor, time, realIntermedia, realOutput, rnpkgInfo, pkgrnVersion, reactNativeBundleArgs, reactNativeBundleProcess, _ref5, isPublish;

    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            platform = (0, _app.checkPlatform)(options.platform);
            dev = options.dev, entryFile = options.entryFile, output = options.output, intermediaDir = options.intermediaDir;
            _getRNVersion = (0, _utils.getRNVersion)(), version = _getRNVersion.version, major = _getRNVersion.major, minor = _getRNVersion.minor;


            if (!entryFile) {
              if (minor >= 49) {
                entryFile = 'index.js';
              } else if (minor < 49) {
                if (platform === 'ios') {
                  entryFile = 'index.ios.js';
                } else if (platform === 'android') {
                  entryFile = 'index.android.js';
                }
              }
            }

            if (!intermediaDir) {
              intermediaDir = 'build/intermedia/' + platform;
            }

            if (!output) {
              time = Date.now();

              output = 'build/output/' + platform + '.' + time + '.ppk';
            }

            realIntermedia = path.resolve(intermediaDir);
            realOutput = output;
            rnpkgInfo = (0, _utils.getRNPackage)();
            pkgrnVersion = rnpkgInfo['dependencies']['react-native'];


            if (version !== pkgrnVersion) {
              console.log(_colors2.default.red('node_modules/react-native/package.json version: ' + version + '\nis not eq\npackage rn version: ' + pkgrnVersion));
            }

            console.log(_colors2.default.green('Bundling with React Native version: ', version));
            _context3.next = 14;
            return rmdir(realIntermedia);

          case 14:
            _context3.next = 16;
            return mkdir(realIntermedia);

          case 16:
            reactNativeBundleArgs = [];


            Array.prototype.push.apply(reactNativeBundleArgs, [path.join('node_modules', 'react-native', 'local-cli', 'cli.js'), 'bundle', '--platform', platform, '--entry-file', entryFile, '--assets-dest', intermediaDir, '--bundle-output', path.join(intermediaDir, 'index.bundlejs'), '--dev', dev === true]);

            reactNativeBundleProcess = child_process.spawn('node', reactNativeBundleArgs);

            console.log('node ' + reactNativeBundleArgs.join(' '));

            _context3.next = 22;
            return reactNativeBundle();

          case 22:

            console.log(_colors2.default.green('Packing'));
            _context3.next = 25;
            return pack(realIntermedia, realOutput);

          case 25:
            _context3.next = 27;
            return _inquirer2.default.prompt([{
              type: 'confirm',
              name: 'isPublish',
              message: 'Would you like to publish it?',
              default: false
            }]);

          case 27:
            _ref5 = _context3.sent;
            isPublish = _ref5.isPublish;

            if (!isPublish) {
              _context3.next = 33;
              break;
            }

            console.log(_colors2.default.green('Publish'));
            _context3.next = 33;
            return (0, _versions.publish)({ platform: platform, ppkFile: realOutput, app_key_path: options.app_key_path });

          case 33:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function bundleApp(_x3) {
    return _ref3.apply(this, arguments);
  };
}();

var _path = require('path');

var path = _interopRequireWildcard(_path);

var _mkdirRecursive = require('mkdir-recursive');

var _rimraf = require('rimraf');

var _rimraf2 = _interopRequireDefault(_rimraf);

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

var _colors = require('colors');

var _colors2 = _interopRequireDefault(_colors);

var _utils = require('./utils');

var _fs = require('fs');

var fs = _interopRequireWildcard(_fs);

var _yazl = require('yazl');

var _app = require('./app');

var _versions = require('./versions');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var child_process = require('child_process');


function mkdir(dir) {
  return new _promise2.default(function (resolve, reject) {
    (0, _mkdirRecursive.mkdir)(dir, function (err) {
      if (err) {
        reject(err);
      } else {
        resolve();
      }
    });
  });
}

function rmdir(dir) {
  return new _promise2.default(function (resolve, reject) {
    (0, _rimraf2.default)(dir, function (err) {
      if (err) {
        reject(err);
      } else {
        resolve();
      }
    });
  });
}