'use strict';

exports.__esModule = true;
exports.deployment = exports.uploadApk = exports.uploadIpa = exports.choosePackage = exports.listPackage = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var listPackage = exports.listPackage = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(app_key) {
    var _ref2, data;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return get('/package/list?app_key=' + app_key);

          case 2:
            _ref2 = _context.sent;
            data = _ref2.data;
            return _context.abrupt('return', data);

          case 5:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function listPackage(_x) {
    return _ref.apply(this, arguments);
  };
}();

var choosePackage = exports.choosePackage = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(appId) {
    var list, packages, bind_packages_result, package_keys;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return listPackage(appId);

          case 2:
            list = _context2.sent;
            packages = list.map(function (pack, index) {
              return 'AppVerion: ' + _colors2.default.blue(pack.app_version) + ' > PackageName: ' + _colors2.default.blue(pack.name);
            });
            _context2.next = 6;
            return _inquire2.default.list('checkbox', 'Please Choose Bind Packages :', packages);

          case 6:
            bind_packages_result = _context2.sent;
            package_keys = [];

            bind_packages_result.index.forEach(function (index) {
              package_keys.push(list[index].key);
            });
            return _context2.abrupt('return', package_keys.join(','));

          case 10:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function choosePackage(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

var uploadIpa = exports.uploadIpa = function () {
  var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(filePath, app_key_path) {
    var app_version, _ref5, appKey, _ref6, hash, name;

    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (filePath) {
              _context3.next = 2;
              break;
            }

            throw new Error('Usage: rnkit-code-push uploadIpa <ipaFile>');

          case 2:
            _context3.next = 4;
            return (0, _utils.getIPAVersion)(filePath);

          case 4:
            app_version = _context3.sent;
            _context3.next = 7;
            return (0, _app.getSelectedApp)('ios', app_key_path);

          case 7:
            _ref5 = _context3.sent;
            appKey = _ref5.appKey;
            _context3.next = 11;
            return uploadFile(filePath);

          case 11:
            _ref6 = _context3.sent;
            hash = _ref6.hash;
            name = _ref6.name;
            _context3.next = 16;
            return post('/package/then_add', {
              app_key: appKey,
              hash: hash,
              file_name: name,
              app_version: app_version,
              name: app_version
            });

          case 16:
            console.log('Ipa uploaded');

          case 17:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function uploadIpa(_x3, _x4) {
    return _ref4.apply(this, arguments);
  };
}();

var uploadApk = exports.uploadApk = function () {
  var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(filePath, app_key_path) {
    var app_version, _ref8, appKey, _ref9, hash, name;

    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            if (filePath) {
              _context4.next = 2;
              break;
            }

            throw new Error('Usage: rnkit-code-push uploadApk <ipaFile>');

          case 2:
            _context4.next = 4;
            return (0, _utils.getApkVersion)(filePath);

          case 4:
            app_version = _context4.sent;
            _context4.next = 7;
            return (0, _app.getSelectedApp)('android', app_key_path);

          case 7:
            _ref8 = _context4.sent;
            appKey = _ref8.appKey;
            _context4.next = 11;
            return uploadFile(filePath);

          case 11:
            _ref9 = _context4.sent;
            hash = _ref9.hash;
            name = _ref9.name;
            _context4.next = 16;
            return post('/package/then_add', {
              app_key: appKey,
              hash: hash,
              file_name: name,
              app_version: app_version,
              name: app_version
            });

          case 16:
            console.log('Ipa uploaded');

          case 17:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function uploadApk(_x5, _x6) {
    return _ref7.apply(this, arguments);
  };
}();

var deployment = exports.deployment = function () {
  var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(platform, app_key_path) {
    var _ref11, appKey, _ref12, data, version_result, packages;

    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return (0, _app.getSelectedApp)(platform, app_key_path);

          case 2:
            _ref11 = _context5.sent;
            appKey = _ref11.appKey;
            _context5.next = 6;
            return get('/version/list?app_key=' + appKey);

          case 6:
            _ref12 = _context5.sent;
            data = _ref12.data;
            _context5.next = 10;
            return _inquire2.default.list('rawlist', 'Please Choose Version :', data.map(function (obj) {
              return obj.name;
            }));

          case 10:
            version_result = _context5.sent;
            _context5.next = 13;
            return choosePackage(appKey);

          case 13:
            packages = _context5.sent;
            _context5.next = 16;
            return post('/package/add_version', {
              version_key: data[version_result.index].key,
              package_key: packages
            });

          case 16:
            console.log(_colors2.default.green('Bind Packages Is Success!'));

          case 17:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function deployment(_x7, _x8) {
    return _ref10.apply(this, arguments);
  };
}();

var _colors = require('colors');

var _colors2 = _interopRequireDefault(_colors);

var _inquire = require('./inquire');

var _inquire2 = _interopRequireDefault(_inquire);

var _app = require('./app');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('./api'),
    get = _require.get,
    post = _require.post,
    uploadFile = _require.uploadFile;