'use strict';

exports.__esModule = true;
exports.publish = exports.listVersions = undefined;

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var showVersion = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(appId, offset) {
    var _ref2, data, table, k;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            console.log('request page ' + offset);
            _context.next = 3;
            return get('/version/list?app_key=' + appId + '&page=' + offset);

          case 3:
            _ref2 = _context.sent;
            data = _ref2.data;

            console.log('Offset ' + offset);
            table = new _cliTable2.default({
              head: ['name', 'release_type', 'is_mandatory', 'is_silent', 'meta_info', 'created_at']
            });

            for (k in data) {
              table.push(['' + data[k].name, '' + data[k].release_type, '' + data[k].is_mandatory, '' + data[k].is_silent, '' + data[k].meta_info, '' + data[k].created_at]);
            }
            console.log('\nTotal ' + data.length + ' packages.');
            console.log(_colors2.default.green(table.toString()));
            return _context.abrupt('return', data);

          case 11:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function showVersion(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var listVersions = exports.listVersions = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(appId) {
    var offset, cmd;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            offset = 0;

          case 1:
            if (!true) {
              _context2.next = 19;
              break;
            }

            _context2.next = 4;
            return showVersion(appId, offset);

          case 4:
            _context2.next = 6;
            return (0, _utils.question)('page Up/page Down/Begin/Quit(U/D/B/Q)');

          case 6:
            cmd = _context2.sent;
            _context2.t0 = cmd.toLowerCase();
            _context2.next = _context2.t0 === 'u' ? 10 : _context2.t0 === 'd' ? 12 : _context2.t0 === 'b' ? 14 : _context2.t0 === 'q' ? 16 : 17;
            break;

          case 10:
            offset = Math.max(0, offset - 1);return _context2.abrupt('break', 17);

          case 12:
            offset += 1;return _context2.abrupt('break', 17);

          case 14:
            offset = 0;return _context2.abrupt('break', 17);

          case 16:
            return _context2.abrupt('return');

          case 17:
            _context2.next = 1;
            break;

          case 19:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function listVersions(_x3) {
    return _ref3.apply(this, arguments);
  };
}();

var getVersionOptions = function () {
  var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
    var options, _ref5, name, release_type_result, gray_type_result, gray_percent_result, _ref6, gray_count, _ref7, condition, _ref8, is_mandatory, _ref9, is_silent, _ref10, description, _ref11, meta_info, _ref12, release_time;

    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            options = {};
            _context3.next = 3;
            return _inquirer2.default.prompt([{
              type: 'input',
              name: 'name',
              default: (0, _moment2.default)().format('YYYYMMDDHHmmss'),
              message: 'Please Input Version Name :'
            }]);

          case 3:
            _ref5 = _context3.sent;
            name = _ref5.name;

            options.name = name;

            _context3.next = 8;
            return _inquire2.default.list('rawlist', 'Please Choose Release Type :', ['Development', 'FullReleased', 'GrayReleased', 'ConditionsReleased']);

          case 8:
            release_type_result = _context3.sent;

            options.release_type = _lodash2.default.parseInt(release_type_result.index) + 1;

            // 灰度下发

            if (!(release_type_result.index === 2)) {
              _context3.next = 30;
              break;
            }

            _context3.next = 13;
            return _inquire2.default.list('rawlist', 'Please Choose Gray Type :', ['Percent', 'Count']);

          case 13:
            gray_type_result = _context3.sent;

            options.gray_type = _lodash2.default.parseInt(gray_type_result.index);

            if (!(gray_type_result.index === 0)) {
              _context3.next = 22;
              break;
            }

            _context3.next = 18;
            return _inquire2.default.list('list', 'The percentage :', ['10%', '20%', '30%', '40%', '50%', '60%', '70%', '80%', '90%']);

          case 18:
            gray_percent_result = _context3.sent;

            options.gray_percent = _lodash2.default.parseInt(gray_percent_result.index) + 1;
            _context3.next = 28;
            break;

          case 22:
            if (!(gray_type_result.index === 1)) {
              _context3.next = 28;
              break;
            }

            _context3.next = 25;
            return _inquirer2.default.prompt([{
              type: 'input',
              name: 'gray_count',
              default: 100,
              message: 'Please Input Gray Count Num : (eg: 100)',
              validate: function validate(input) {
                var done = this.async();
                if (_validator2.default.isNumeric(input)) {
                  done(null, true);
                } else {
                  console.log(_colors2.default.red('You need to provide a number'));
                }
              }
            }]);

          case 25:
            _ref6 = _context3.sent;
            gray_count = _ref6.gray_count;

            options.gray_count = _lodash2.default.parseInt(gray_count);

          case 28:
            _context3.next = 36;
            break;

          case 30:
            if (!(release_type_result.index === 3)) {
              _context3.next = 36;
              break;
            }

            _context3.next = 33;
            return _inquirer2.default.prompt([{
              type: 'input',
              name: 'condition',
              message: 'Please Input Release Condition : (eg: ios>=9)'
            }]);

          case 33:
            _ref7 = _context3.sent;
            condition = _ref7.condition;

            options.condition = condition;

          case 36:
            _context3.next = 38;
            return _inquirer2.default.prompt([{
              type: 'confirm',
              name: 'is_mandatory',
              message: 'This Version Is Mandatory?',
              default: false
            }]);

          case 38:
            _ref8 = _context3.sent;
            is_mandatory = _ref8.is_mandatory;

            options.is_mandatory = is_mandatory ? 1 : 0;

            if (is_mandatory) {
              _context3.next = 47;
              break;
            }

            _context3.next = 44;
            return _inquirer2.default.prompt([{
              type: 'confirm',
              name: 'is_silent',
              message: 'This Version Is Silent?',
              default: false
            }]);

          case 44:
            _ref9 = _context3.sent;
            is_silent = _ref9.is_silent;

            options.is_silent = is_silent ? 1 : 0;

          case 47:
            _context3.next = 49;
            return _inquirer2.default.prompt([{
              type: 'input',
              name: 'description',
              message: 'This Version Release Description: '
            }]);

          case 49:
            _ref10 = _context3.sent;
            description = _ref10.description;

            description ? options.description = description : null;

            _context3.next = 54;
            return _inquirer2.default.prompt([{
              type: 'input',
              name: 'meta_info',
              message: 'This Version Release meta_info: ',
              validate: function validate(input) {
                var done = this.async();
                if (!input) {
                  done(null, true);
                  return;
                }
                if (!_validator2.default.isJSON(input)) {
                  console.log(_colors2.default.red('You need to provide a JSON'));
                } else {
                  done(null, true);
                }
              }
            }]);

          case 54:
            _ref11 = _context3.sent;
            meta_info = _ref11.meta_info;

            meta_info ? options.meta_info = meta_info : null;

            _context3.next = 59;
            return _inquirer2.default.prompt([{
              type: 'input',
              name: 'release_time',
              message: 'This Version Release Time? (eg: xxxx-xx-xx xx:xx:xx)',
              validate: function validate(input) {
                var done = this.async();
                if (!input) {
                  done(null, true);
                  return;
                }
                if (_validator2.default.isDate(input) && (0, _moment2.default)(input).isAfter((0, _moment2.default)().format('YYYY-MM-DD HH:mm:ss'))) {
                  done(null, true);
                } else {
                  console.log(_colors2.default.red('You need to provide a date, eg: xxxx-xx-xx xx:xx:xx'));
                }
              }
            }]);

          case 59:
            _ref12 = _context3.sent;
            release_time = _ref12.release_time;

            release_time ? options.release_time = release_time : null;

            return _context3.abrupt('return', options);

          case 63:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function getVersionOptions() {
    return _ref4.apply(this, arguments);
  };
}();

var publish = exports.publish = function () {
  var _ref13 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(args) {
    var platform, ppkFile, app_key_path, options, app_info, _ref14, hash, name, _ref15, key, _ref16, is_bind_package, packages;

    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            platform = args.platform, ppkFile = args.ppkFile, app_key_path = args.app_key_path;
            _context4.next = 3;
            return (0, _app.checkPlatform)(platform);

          case 3:
            if (ppkFile) {
              _context4.next = 5;
              break;
            }

            throw new Error('Usage: rnkit-code-push publish <ppkFile> --platform ios|android');

          case 5:
            _fs2.default.statSync(ppkFile);

            _context4.next = 8;
            return getVersionOptions();

          case 8:
            options = _context4.sent;
            _context4.next = 11;
            return (0, _app.getSelectedApp)(platform, app_key_path);

          case 11:
            app_info = _context4.sent;
            _context4.next = 14;
            return uploadFile(ppkFile);

          case 14:
            _ref14 = _context4.sent;
            hash = _ref14.hash;
            name = _ref14.name;
            _context4.next = 19;
            return post('/version/create', (0, _assign2.default)(options, {
              file_name: name,
              hash: hash,
              app_key: app_info.appKey
            }));

          case 19:
            _ref15 = _context4.sent;
            key = _ref15.key;

            console.log(_colors2.default.green('Version published'));

            _context4.next = 24;
            return _inquirer2.default.prompt([{
              type: 'confirm',
              name: 'is_bind_package',
              message: 'Would you like to bind packages to this version?',
              default: false
            }]);

          case 24:
            _ref16 = _context4.sent;
            is_bind_package = _ref16.is_bind_package;

            if (!is_bind_package) {
              _context4.next = 35;
              break;
            }

            _context4.next = 29;
            return (0, _package.choosePackage)(app_info.appKey);

          case 29:
            packages = _context4.sent;
            _context4.next = 32;
            return post('/package/add_version', {
              version_key: key,
              package_key: packages
            });

          case 32:
            console.log(_colors2.default.green('Bind Packages Is Success!'));
            _context4.next = 36;
            break;

          case 35:
            process.exit(1);

          case 36:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function publish(_x4) {
    return _ref13.apply(this, arguments);
  };
}();

var _cliTable = require('cli-table2');

var _cliTable2 = _interopRequireDefault(_cliTable);

var _colors = require('colors');

var _colors2 = _interopRequireDefault(_colors);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _validator = require('validator');

var _validator2 = _interopRequireDefault(_validator);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _utils = require('./utils');

var _app = require('./app');

var _package = require('./package');

var _inquire = require('./inquire');

var _inquire2 = _interopRequireDefault(_inquire);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('./api'),
    get = _require.get,
    post = _require.post,
    uploadFile = _require.uploadFile;